<?php
/**
 * InterWorx Hosting Control Panel
 *
 * <pre>
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2000-2008 InterWorx L.L.C., All Rights Reserved.       |
 * +----------------------------------------------------------------------+
 * | Redistribution and use in source form, with or without modification  |
 * | is NOT permitted without consent from the copyright holder.          |
 * |                                                                      |
 * | THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS "AS IS" AND |
 * | ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,    |
 * | THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A          |
 * | PARTICULAR PURPOSE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,    |
 * | EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,  |
 * | PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR   |
 * | PROFITS; OF BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY  |
 * | OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT         |
 * | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE    |
 * | USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH     |
 * | DAMAGE.                                                              |
 * +----------------------------------------------------------------------+
 * </pre>
 *
 * @package InterWorx
 * @author  Jonathan Daniel <jdaniel@interworx.com>
 * @date    Jun 30, 2009
 * @id $Id: iworx-login.php,v 1.7 2009/07/14 20:30:57 jdaniel Exp $
 */

ini_set( 'session.save_path', '/tmp' );

/**
 * Login to PHPMyAdmin function.
 *
 * Sets the required session variables and redirects
 */
function login_to_pma() {
  $cmd = '/home/interworx/lib/phpMyAdmin/phpmyadmin';

  if( isset( $_GET['hint'] ) && $_GET['hint'] == 'nodeworx' ) {
    $cmd         .= ' --nodeworx';
    $session_type = 'nodeworx';
  } else {
    $cmd         .= ' --siteworx';
    $session_type = 'siteworx';
  }
  if( isset( $_GET['domain'] ) ) {
    $cmd .= ' --domain=' . $_GET['domain'];
  } else if( isset( $_GET['server'] ) ) {
    $cmd .= ' --server=' . $_GET['server'];
  }

  exec( escapeshellcmd( $cmd ), $result, $retval );

  require_once( '../pear/PEAR.php' );
  require_once( '../pear/DB.php' );

  if( $retval == 0 ) {
    session_name( 'phpMyAdmin' );
    session_start();

    //we need the id for later
    $id = session_id();
    setcookie( 'phpMyAdmin', $id, time()+3600, '/mysql/' );
    setcookie( 'pmaCookieVer', '4', time()+3600, '/mysql/' );

    $dsn = $result[0];

    $p    = DB::parseDSN( $dsn );
    $host = $p['hostspec'];
    if( empty( $host ) ) {
      $host = 'localhost';
    }

    $socket   = $p['socket'];
    $hostspec = $p['hostspec'];
    $port     = $p['port'];

    $_SESSION['PMA_single_signon_user']     = $p['username'];
    $_SESSION['PMA_single_signon_password'] = $p['password'];
    $_SESSION['PMA_single_signon_host']     = $host;
    $_SESSION['PMA_single_signon_socket']   = $socket;
    $_SESSION['PMA_single_signon_hostspec'] = $hostspec;
    $_SESSION['PMA_single_signon_port']     = $port;
    $_SESSION['PMA_single_signon_type']     = $session_type;

    session_write_close();

    header( 'Location: /mysql/index.php?server=1&phpMyAdmin=' . $id );
  } else {
    print implode( '<br />', $result );
    exit();
  }//end if
}

/**
 * Logs out of PHPMyAdmin by killing the session and redirecting
 *
 */
function logout_of_pma() {

  session_set_cookie_params( 0, '/mysql/', '', 0 );
  if( isset( $_GET['phpMyAdmin'] ) ) {
    session_id( $_GET['phpMyAdmin'] );
  }
  session_name( 'phpMyAdmin' );
  session_start();

  $type = $_SESSION['PMA_single_signon_type'];
  if( $type == 'siteworx' ) {
    $redir = '/siteworx/overview';
  } else if( $type == 'nodeworx' ) {
    $redir = '/nodeworx/mysql/phpmyadmin/';
  } else {
    $redir = '/';
  }

  session_unset();
  session_destroy();

  header( "Location: $redir" );
}

$action = ( isset( $_GET['action'] ) ) ? $_GET['action'] : null;
if( $action == 'login' ) {
  login_to_pma();
} else if( $action == 'logout' ) {
  logout_of_pma();
} else {
  print 'Please login via your control panel';
  exit();
}
?>